document.getElementById("SymbioteId").innerHTML = "<I>Detecting...</I>";

var subscription = "";

function onSubscription(event) {
	sLog("Message Type: " + event.kind);

	if (event.kind === "hasInitialized") { hasInitialized(event); }
	if (event.kind === "urlMessageReceived") { urlMessageReceived(event); }

	var sendNotification = (subscription.indexOf(event.kind) > -1);
	if (event.kind === "chatMessageReceived" && (event.payload.body.startsWith("API:") || event.payload.body.startsWith("EVENT:"))) { sendNotification = false; }

	if (sendNotification) {
		TS.players.whoAmI()
			.then((player) => {
				sLog("Symbiote API Sending Event Notification (To Player Id: " + player.id + "): " + JSON.stringify(event));
				TS.chat.send("EVENT:" + JSON.stringify(event), player.id);
			})
			.catch((error) => {
				sLog("Error: " + error);
			});
	}
}

function hasInitialized(event) {
	TS.urls.createUrlPrefixForThisSymbiote()
		.then((id) => {
			sLog("Symbiote API Prefix Id: " + id);
			document.getElementById("SymbioteId").innerHTML = id;
			TS.players.whoAmI().then((player) => {
				sLog("Symbiote API Player Id: " + player.id);
				TS.chat.send("API:" + id, player.id);
			});
		})
		.catch((error) => {
			sLog("Error: " + error);
			document.getElementById("SymbioteId").innerHTML = error;
		});
}

function urlMessageReceived(event) {
	var msg = event.payload.str;
	msg = decodeURIComponent(msg);
	msg = msg.replaceAll("", " "); // Replace ALT+255 with space
	if (msg.toUpperCase().startsWith("API:")) {
		msg = msg.substring(4);
		sLog("Symbiote API Executing: " + msg);
		eval(msg);
		return;
	}
}

function Subscribe(subscribedEventsList) {
	sLog("Symbiote API User Subscribed To Events: " + subscribedEventsList);
	subscription = subscribedEventsList;
}
